from urlparse import urlparse
 
class Address(object):
    
    def __init__(self,*args):
        super(Address,self).__init__()
        args = filter(lambda x : x,args)
        if len(args) < 1:
            raise ValueError('Provide at least one argument')
        
        if len(args) < 2:
            self._result = urlparse(\
                        '//{host_and_port}'.format(host_and_port = args[0]))
            return
        
        if ':' in args[0]:
            raise ValueError(\
            'Specify port either as part of hostname, or as the second argument')
        
        self._result = urlparse(\
                        '//{host}:{port}'.format(host = args[0],port = args[1]))
    
    @property
    def host(self):
        return self._result.hostname
    
    @property
    def port(self):
        return self._result.port
    
    def __iter__(self):
        return (x for x in (self.host,self.port))
    
    def __getitem__(self,index):
        if index == 0:
            return self.host
        if index == 1:
            return self.port
        raise IndexError()
    
    def __str__(self):
        return '{host}{sep}{port}'.format(\
                    host = self.host,
                    sep = ':' if self.port else '',
                    port = self.port or '')
