import argparse

def get_parser(): 
    parser = argparse.ArgumentParser()
    aa = parser.add_argument
    aa('--host',
       help = 'the hostname',
       default = 'localhost',
       type=str)
    aa('--port',
       help = 'the port the node should listen on',
       default = 8080,
       type=int)
    aa('--entree',
       help = 'the host and port of any other node, e.g., 192.168.1.1:8080',
       type=str)
    aa('--replicas',
       help = 'the number of replicas of data that should exist',
       default = 1,
       type=int)
    aa('--redisport',
       help = 'the port redis is listening on',
       default = 6379,
       type=int)
    aa('--dbpath',
       help = 'the path to a directory where data for this node will be stored',
       type=str)
    aa('--initialsize',
       help = 'initial size of the data file, in bytes',
       type=int,
       default = 1000 * 1024 * 100)
    aa('--groupby',
       help = 'pack keys together in the data file according to this computed value',
       type=str,
       default = 'lambda x : x')
    aa('--hash',
       help = 'hash keys using this function',
       type=str,
       default = 'lambda x : x')
    aa('--nodename',
       help = 'A string whose hashed value will be this node\'s id.',
       type=str,
       default = None)
    aa('--location',
       help = 'the hostname to be used when building the location header on a PUT response',
       default = None)
    aa('--secret_key',
       help = 'password',
       default = None)
    aa('--ip',
       help = 'ip address',
       default = None)
    aa('--public_addr',
       help = 'the publicly accessible host and port that should be broadcast to other nodes',
       default = None)
    return parser