import os
from journal import BaseInsertion

# TODO: This is a terrible name!
class FileWithClose(file):
    
    def __init__(self,key,content_type,timestamp,path,callback):
        self.key = str(key)
        self.content_type = content_type
        self.path = path
        self.timestamp = timestamp
        self.fn = '_{timestamp}.dat'.format(timestamp = timestamp)
        self.fp = os.path.join(self.path,self.fn)
        super(FileWithClose,self).__init__(self.fp,'wb')
        self.callback = callback
        self._init = False
    
    def write(self,data):
        if not self._init:
            bs = BaseInsertion(_id = self.key,content_type = self.content_type)
            super(FileWithClose,self).write(bs.bytes)
            self._init = True
        
        super(FileWithClose,self).write(data)
    
    def __enter__(self):
        return self
    
    def __exit__(self,t,value,traceback):
        self.close()
    
    def close(self):
        self.flush()
        super(FileWithClose,self).close()
        self.callback(self)
    
# TODO: This is not the best name
class ReadonlyFile(object):
    
    def __init__(self,mapped,meta):
        if (meta.offset + meta.size) > len(mapped):
            raise BufferError()
        super(ReadonlyFile,self).__init__()
        self._m = mapped
        self.meta = meta
        self.offset = meta.offset
        self.pos = 0
        self.length = meta.size
        self.content_type = meta.content_type
        self.hexdigest = meta.hexdigest
        self.timestamp = meta.timestamp
    
    def __enter__(self):
        return self
    
    def __exit__(self,t,value,traceback):
        self.close()
    
    def __del__(self):
        self.close()
    
    def close(self):
        self.closed = True
    
    def fileno(self):
        raise NotImplemented()
    
    def flush(self):
        raise NotImplemented()
    
    def isatty(self):
        return False
    
    def readable(self):
        return True
    
    def readline(self):
        raise NotImplemented()
    
    def readlines(self):
        raise NotImplemented()
    
    def read(self,size = None):
        if not size:
            size = self.length
        rs = min(size,self.length - self.pos)
        rp = self.offset + self.pos
        d = self._m[rp : rp + rs]
        self.pos += rs
        return d
    
    def seek(self,offset,whence = 0):
    
        if not whence:
            self.pos = self._nonnegative(offset)
            return
        
        if 1 == whence:
            self.pos = self._nonnegative(self.pos + offset)
            return
        
        if 2 == whence:
            self.pos = self._nonnegative(self.length + offset)
            return
        
        raise IOError()
    
    def _nonnegative(self,x):
        if x < 0: raise IOError()
        return x
    
    def seekable(self):
        return True
    
    def tell(self):
        return self.pos
    
    def truncate(self,size = None):
        raise NotImplemented()
    
    def writable(self):
        return False
    
    def writelines(self,lines):
        raise NotImplemented()
        
    def write(self,s):
        raise NotImplemented()
