try:
    from oliver.node import Node,application
    from oliver.nginx_conf import *
    from oliver.argparser import get_parser
except ImportError:
    from node import Node,application
    from nginx_conf import *
    from argparser import get_parser

import tornado
import requests

if __name__ == '__main__':
    parser = get_parser()
    aa = parser.add_argument
    # nginx stuff
    aa('--nginx_config_path',
       help = 'absolute path to nginx configuration file',
       default = None)
    args = parser.parse_args()
    
    upstreams = [UpstreamServer(args.host,args.port)]
    if args.entree:
        upstreams.append(UpstreamServer(*args.entree.split(':')))
    
    mu = MainUpstream('main',upstreams,args.replicas) 
    servers = [ServerConfig(80,mu)]
    config = NginxConfig(\
                [],
                mu,
                servers,
                path = args.nginx_config_path,
                alias = args.public_addr)
    print config
    config.start()
    
    if not args.public_addr:
        resp = requests.get('http://wtfismyip.com/json')
        args.public_addr = resp.json()['YourFuckingIPAddress']
        print 'Public IP is %s' % args.public_addr
    
    if not args.ip:
        args.ip = args.public_addr.split(':')[0]
        
    if not args.secret_key:
        args.secret_key = 'oliver'
        print 'WARNING: You did not specify a secret key, so it is "%s"' \
                % args.secret_key
        
    with Node(\
        args.host,
        args.port,
        args.entree,
        args.replicas,
        args.redisport,
        args.dbpath,
        args.initialsize,
        eval(args.groupby),
        eval(args.hash),
        args.nodename,
        args.location,
        args.secret_key,
        args.ip,
        args.public_addr,
        nginx_conf = config) as node:
        node.start_server()
        application.listen(node.port)
        tornado.ioloop.IOLoop.instance().start()
    
    